/* eslint-disable @typescript-eslint/no-var-requires */
// 这里webpack loader 使用 commonjs 语法
const path = require('path')

module.exports = function (source) {
  const callback = this.async()
  const pluginName = path.basename(path.dirname(this.resourcePath))
  import('@thing.js/cli-utils').then((mod) => {
    let parsed = mod.PropsParser.parse(source, {
      targetClass(p) {
        return (
          p.node.superClass?.object?.name === 'THING' &&
          p.node.superClass?.property?.name === 'BasePlugin'
        )
      },
      noTargetClassTip() {
        return `插件 ${pluginName}/index.js 文件没有找到一个继承自 THING.BasePlugin 的类, 将忽略生成 props`
      },
    })

    callback(null, parsed.source)
  })
}
